unit ueditarfichasumcomb;


interface

uses
{$IFDEF FPC-LCL}
  LResources,
{$ENDIF}

{$IFDEF WINDOWS}
 Windows,
 {$ELSE}
 LCLType,
 {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,
  StdCtrls, Grids,
  CheckLst, uglobs, ufichasLPD, uBaseEditoresFichas,
  utilidades, uFechas, uBaseAltasEditores, uCosaConNombre, ExtCtrls, uconstantesSimSEE,
  usalasdejuego,
  uBaseEditoresFichasGeneradores,
  xMatDefs,
  uSalasDeJuegoParaEditor, uverdoc,
  uFuentesAleatorias,
  utsumcomb,
  uOpcionesSimSEEEdit;

resourcestring
  rsQMax = 'QMax [m3/s]';
  rsPrecio = 'Precio [USD/m3]';
  rsCoeficienteDisponibilidadFortuita = 'Coeficiente de disponibildad fortuita[p.u.]';
  rsTiempoDeReparacionH = 'Tiempo de reparación[horas]';

type

  { TEditarfichasumcomb }

  TEditarfichasumcomb = class(TBaseEditoresFichasGeneradores)
    CBFuenteIndicePreciosCombustible: TComboBox;
    CBBorneIndicePreciosCombustible: TComboBox;
    IntFicha: TStringGrid;
    BGuardar: TButton;
    BCancelar: TButton;
    LFIni: TLabel;
    EFIni: TEdit;
    CBPeriodicidad: TCheckBox;
    PPeriodicidad: TPanel;
    LFinPeriodo: TLabel;
    LIniPeriodo: TLabel;
    LLargoPeriodo: TLabel;
    EFFinPeriodo: TEdit;
    EFIniPeriodo: TEdit;
    sgPeriodicidad: TStringGrid;
    ELargoPeriodo: TEdit;
    CBLargoPeriodo: TComboBox;
    BAyuda: TButton;
    procedure EFIniChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EditEnter(Sender: TObject);
    procedure BCancelarClick(Sender: TObject);
    procedure sgGetEditText(Sender: TObject; ACol, ARow: integer; var Value: string);
    procedure BGuardarClick(Sender: TObject); override;
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure CBPeriodicidadClick(Sender: TObject);
    procedure BAyudaClick(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure sgChequearCambios(Sender: TObject);
    procedure sgChequearCambiosKeyDown(Sender: TObject; var Key: word;
      Shift: TShiftState);
  protected
    function validarFormulario(): boolean; override;
  private
    Generador: TSuministroSimpleCombustible;
  public
    constructor Create(AOwner: TComponent; cosaConNombre: TCosaConNombre;
      ficha: TFichaLPD; sala: TSalaDeJuego); override;
  end;

implementation

uses SimSEEEditMain;

  {$R *.lfm}

constructor TEditarfichasumcomb.Create(AOwner: TComponent;
  cosaConNombre: TCosaConNombre; ficha: TFichaLPD; sala: TSalaDeJuego);
var
  fichaAux: TFichaSuministroSimpleCombustible;
  i: integer;
begin
  inherited Create(AOwner, cosaConNombre, ficha, sala);
  Generador := cosaConNombre as TSuministroSimpleCombustible;
  guardado := True;
  inherited llenarCamposPeriodicidad(CBLargoPeriodo, ELargoPeriodo,
    EFIniPeriodo, EFFinPeriodo, sgPeriodicidad, CBPeriodicidad, ficha, PPeriodicidad);
  inherited inicializarCBFuente(
    CBFuenteIndicePreciosCombustible,
    CBBorneIndicePreciosCombustible, True);

  if (ficha <> nil) then
  begin
    fichaAux := ficha as TFichaSuministroSimpleCombustible;
    self.EFIni.Text := FSimSEEEdit.fechaIniToString(fichaAux.fecha);
    self.IntFicha.cells[1, 0] := FloatToStr(fichaAux.QMax);
    self.IntFicha.cells[1, 1] := FloatToStr(fichaAux.Precio);
    self.IntFicha.cells[1, 2] := FloatToStr(fichaAux.fd);
    self.IntFicha.Cells[1, 3] := FloatToStr(fichaAux.TMR);
    inherited setCBFuente(CBFuenteIndicePreciosCombustible,
        CBBorneIndicePreciosCombustible, fichaAux.indicePreciosPorCombustible,
        fichaAux.bornePreciosPorCombustible);
  end
  else
  begin
    self.EFIni.Text := '';
    for i := 0 to self.IntFicha.RowCount - 1 do
      self.IntFicha.cells[1, i] := '';
  end;
end;

function TEditarFichasumcomb.validarFormulario(): boolean;
begin
  inherited validarFormulario;
  Result := validarEditFecha(EFIni) and inherited validarPeriodicidad(
    CBPeriodicidad, CBLargoPeriodo, ELargoPeriodo, EFIniPeriodo,
    EFFinPeriodo, sgPeriodicidad)
    and inherited validarTablaNReals_(IntFicha)
    and inherited validarCBFuente(CBFuenteIndicePreciosCombustible,
    CBBorneIndicePreciosCombustible, 0);
end;

procedure TEditarFichasumcomb.FormCreate(Sender: TObject);
begin
  utilidades.AgregarFormatoFecha(LFIni);

  self.IntFicha.cells[0, 0] := rsQMax;
  self.IntFicha.cells[0, 1] := rsPrecio;
  self.IntFicha.cells[0, 2] := rsCoeficienteDisponibilidadFortuita;
  self.IntFicha.cells[0, 3] := rsTiempoDeReparacionH;

  utilidades.AutoSizeCol(IntFicha, 0);
  utilidades.AutosizeTable(self, IntFicha, maxAnchoTablaEnorme,
    maxAlturaTablaChica, TSimSEEEditOptions.getInstance.
    deshabilitarScrollHorizontalEnListados);
end;

procedure TEditarfichasumcomb.EFIniChange(Sender: TObject);
begin

end;

procedure TEditarFichasumcomb.BGuardarClick(Sender: TObject);
var
  periodicidad: TPeriodicidad;
begin
  if validarFormulario then
  begin
  {  fAux := TFichaGenSencillo(Generador.lpd.ficha(StrToInt(self.IntAnio.text), StrToInt(self.IntSemana.text)));
  if (fAux = NIL) or (fAux = ficha2) then
     begin          }
    if not CBPeriodicidad.Checked then
      periodicidad := nil
    else
      periodicidad := inherited darPeriodicidad(CBLargoPeriodo,
        ELargoPeriodo, EFIniPeriodo, EFFinPeriodo, sgPeriodicidad);


    ficha := TFichaSuministroSimpleCombustible.Create(
      capa, FSimSEEEdit.StringToFecha(EFIni.Text),
      periodicidad,
      StrToFloat(self.IntFicha.cells[1, 0]),
      StrToFloat(self.IntFicha.cells[1, 1]),
      valorCBFuente(
      CBFuenteIndicePreciosCombustible), valorCBString(
      CBBorneIndicePreciosCombustible),
      StrToFloat(self.IntFicha.cells[1, 2]),
      StrToFloat(self.IntFicha.cells[1, 3])
      );


  end;
end;

procedure TEditarFichasumcomb.EditEnter(Sender: TObject);
begin
  inherited EditEnter(Sender);
end;

procedure TEditarFichasumcomb.EditExit(Sender: TObject);
begin
  inherited EditExit(Sender);
end;

procedure TEditarFichasumcomb.BCancelarClick(Sender: TObject);
begin
  inherited BCancelarClick(Sender);
end;

procedure TEditarFichasumcomb.sgChequearCambios(Sender: TObject);
begin
  inherited sgChequearCambios(Sender);
end;

procedure TEditarFichasumcomb.sgChequearCambiosKeyDown(Sender: TObject;
  var Key: word; Shift: TShiftState);
begin
  inherited sgChequearCambiosKeyDown(Sender, Key, Shift);
end;

procedure TEditarFichasumcomb.sgGetEditText(Sender: TObject;
  ACol, ARow: integer; var Value: string);
begin
  inherited sgGetEditText(Sender, ACol, ARow, Value);
end;

procedure TEditarFichasumcomb.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
begin
  inherited FormCloseQuery(Sender, CanClose);
end;

procedure TEditarFichasumcomb.CBPeriodicidadClick(Sender: TObject);
begin
  inherited switchPanelPeriodicidad(CBPeriodicidad, PPeriodicidad);
end;



procedure TEditarFichasumcomb.BAyudaClick(Sender: TObject);
begin
  verdoc(self, TSuministroSimpleCombustible);
end;

initialization
end.
